<template>
  <div class="voucher-air-drop">
    <p class="title-component">
      {{ $t('bounty.voucher.title') }}
    </p>

    <div class="article-group">
      <div class="article-item">
        <div class="article__content">
          <div class="article__text" >
            <span v-if="!vouchers.length">{{ $t('bounty.voucher.paste') }}</span>
          </div>
          <div class="article-input-wrapper">
            <div class="article__input-link" v-if="!vouchers.length">
              <input type="text" @focus="resetError" data-vv-as="voucher code"
                v-validate="'required'"
                data-vv-validate-on="none"
                name="voucher"
                class="article__url"
                :placeholder="`${$t('bounty.voucher.paste')} ...`"
                v-model="voucher"
                @keyup.enter="create()"
              >
              <span class="article__btnAdd" @click="create()"></span>
              <br>
              <span class="error show" v-if="errors.has('voucher')">{{ errors.first('voucher') }}</span>
            </div>
            <div class="article__link-group" v-for="item in vouchers">
              <div class="article__link-item">
                <div class="link">
                  {{ item.meta_data }}
                </div>
                <div class="bounty">
                  {{ (item.status === 'approved' ? item.heta_tokens : 0) | formatCurrencyAmount('heta', '0') }}
                </div>

                <div :class="`status ${item.status}`">
                  {{ item.status | upperFirst }}
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import { mapState } from 'vuex';

import rf from '../../../common/requests/RequestFactory';

export default {
  data() {
    return {
      voucher: '',
      vouchers: [],
      total: 0,
    };
  },
  methods: {
    resetError () {
      this.errors.clear();
    },
    create () {
      this.$validator.validateAll()
        .then(() => {
          if (this.errors.any()) {
            return;
          }
          const params = {
            user_id: this.user.id,
            voucher: this.voucher,
            type: 'voucher'
          };
          rf.getRequest('BountyRequest').createBountyVoucher(params)
            .then(() => {
              this.voucher = '';
              this.getAllBountyVoucher();
            })
            .catch((error) => {
              const errors = error.errors;
              this.errors.clear();
              Object.keys(errors).forEach((key) => {
                this.errors.add({
                  field: key,
                  msg: errors[key][0]
                });
              });
            });
        });
    },
    async getAllBountyVoucher () {
      const result = await rf.getRequest('BountyRequest').getAllBountyVoucher();
      this.vouchers = [...result.data];
      this.total = result.data
                    .filter(item => item.status === 'approved')
                    .reduce((sum, item) => {
                      return sum + item.voucher.token;
                    }, 0);
    }
  },
  computed: {
    ...mapState([
      'user',
    ]),
  },
  created () {
    this.getAllBountyVoucher();
  },
};
</script>
<style scoped lang="scss">
  .voucher-air-drop {
    padding: 30px 0 30px;
  }

  .title-component {
    margin-bottom: 9px;
  }

  .article-item {
    margin-bottom: 0;
    .article__title {
      font-size: 1rem;
      margin-bottom: 10px;
    }
    .article__content {
      color: #858585;
      font-size: 0.75rem;
      margin-bottom: 0;
    }
    
    .article__input-link {
      font-size: 0;
      margin-bottom: 0;
    }
    .article__url {
      vertical-align: middle;
      padding: 6px 10px;
      width: calc(100% - 156px);
      font-size: 13px;
      color: #222c3c;
      border: 1px solid #d2d2d2;
      background-color: #fff;
      border-radius: 74px;

      &::placeholder {
        font-size: 13px;
      }
    }
    .article__text {
      font-size: 13px;
      color: #222c3c;
      letter-spacing: 0.5px;
      margin-bottom: 6px;
    }
    .article__description {
      font-size: 0.875rem;
      margin-bottom: 27px;
    }
    .article__link-group {
      .article__link-item {
        font-size: 0;
        margin-bottom: 10px;
        .bounty,
        .link,
        .status {
          display: inline-block;
          width: 100px;
          padding: 5px 10px;
          margin-right: 10px;
          font-size: 13px;
          background-color: #ebebeb;
          vertical-align: middle;
          color: #222c3c;
          border-radius: 74px;
          border: 1px solid #d8dbe7;
        }
        .link {
          color: #222c3c;
          width: calc(100% - 220px);
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
          text-align: center;
        }

        .status {
          margin-right: 0;
          text-align: center;
          font-weight: bold;
          &.pending {
            color: #fcb202;
          }
          &.rejected {
            color: #d0021b;
          }
          &.approved {
            color: #4caf50;
          }
        }
      }
    }
  }
  .error {
    color: red;
    display: inline-block;
    margin-bottom: 5px;
    font-size: 12px;
    padding-left: 10px;
    display: none;
    transition: all 0.3s ease-in-out;
    padding: 0 !important;
    &.show {
      display: block;
    }
  }

  .article__link-group {
    width: 100% !important;
  }
</style>
